#include "chdecl.h"
void CH_normalize3(current, sched, cop)
#define ARGUMENTS 5
#include "chhead.h"
select: switch (SELECTOR) {
    case 0: goto c0;
    case 1: goto cb1;
    case 2: goto c2;
    case 3: goto c5;
    case 4: goto c31;  }
c0:
/* block , 0 */
  if((ch_returncode = che_block(QUAL(0),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 1;
cb1:
/* receive 3 0 */
  if ((ch_returncode = che_receive(DEF(3),DEF(0),sched)) != Normal)
     goto ch_raise_exception;
  return;
c2:
/* noop */
  
/* idivide 4 3.0 =(2) */
  REF(4).value.integer = REF(3)DOT(0).value.integer/2;
  REF(4).tsdr = & dr_integer;
c5:
/* ige . 3.3 4 , 28 */
  if ( REF(3)DOT(3).value.integer >= REF(4).value.integer ) goto c28;
/* imultiply 5 =(2) 3.1 */
  if (!chf_imultiply(DEF(5),2,REF(3)DOT(1).value.integer)) goto ch_depletion;
/* imultiply 6 =(2) 3.2 */
  if (!chf_imultiply(DEF(6),2,REF(3)DOT(2).value.integer)) goto ch_depletion;
/* idivide 7 5 3.0 */
  if (REF(3)DOT(0).value.integer == 0) goto ch_dividebyzero;
  REF(7).value.integer = REF(5).value.integer/REF(3)DOT(0).value.integer;
  REF(7).tsdr = & dr_integer;
/* iadd 8 6 7 */
  if (!chf_iadd(DEF(8),REF(6).value.integer,REF(7).value.integer))
     goto ch_depletion;
/* imultiply 9 =(2) 3.3 */
  if (!chf_imultiply(DEF(9),2,REF(3)DOT(3).value.integer)) goto ch_depletion;
/* idivide 10 8 3.0 */
  if (REF(3)DOT(0).value.integer == 0) goto ch_dividebyzero;
  REF(10).value.integer = REF(8).value.integer/REF(3)DOT(0).value.integer;
  REF(10).tsdr = & dr_integer;
/* iadd 3.3 9 10 */
  if (!chf_iadd(DEF(3)DOT(3),REF(9).value.integer,REF(10).value.integer))
     goto ch_depletion;
/* imod 3.2 8 3.0 */
  if (REF(3)DOT(0).value.integer == 0) goto ch_dividebyzero;
  if (!chf_imod(DEF(3)DOT(2),REF(8).value.integer,REF(3)DOT(0).value.integer))
     goto ch_depletion;
/* imod 3.1 5 3.0 */
  if (REF(3)DOT(0).value.integer == 0) goto ch_dividebyzero;
  if (!chf_imod(DEF(3)DOT(1),REF(5).value.integer,REF(3)DOT(0).value.integer))
     goto ch_depletion;
/* isubtract 3.4 3.4 =(1) */
  if (!chf_isubtract(DEF(3)DOT(4),REF(3)DOT(4).value.integer,1))
     goto ch_depletion;
/* branch , 5 */
   goto c5;
c28:
/* return 3 */
  if (ch_caller = do_return(REF(3).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(3).value);
  REF(3).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
c31:
/* endprocess */
  che_endprocess(sched); return;
#include "chtail.h"
